/*
 * Author: Michael Finkenberger
 * @since V1.3.0.3
 * Last change in plugin version: V1.4.0.0
 * Date: 18.05.2021
 * Tested with plugin version: V1.4.0.0
*/

var $ = jQuery;
var mfem_timeout;
var mfem_cursor;

var mfem_delay_default = 400; // the default value
var mfem_delay = mfem_delay_default; // delay before to show the mfem_tooltip in ms
var mfem_d_y_default = 14; // the default value
var mfem_d_x_default = 14; // the default value
var mfem_d_y = mfem_d_y_default; // Horizontal distance between mousepointer and mfem_tooltip in pixels
var mfem_d_x = mfem_d_x_default; // Horizontal distance between mousepointer and mfem_tooltip in pixels



$(document).ready(function() {
  // Tooltips
  var mfem_jqueryTooltip = $('<div id="mfem_jqueryTooltip"></div>');
  $('body').append(mfem_jqueryTooltip);
  $('[mfem_tooltip]').hover(function(e) { // Mouse in
    mfem_cursor = $('html,body').css('cursor'); // Store current cursor type
    $('html,body').css('cursor','help'); // Change the cursor as wanted
    var mfem_this = $(this);
    if ( mfem_this.attr('mfem_tooltip_delay') ) mfem_delay = mfem_this.attr('mfem_tooltip_delay'); // Set delay, if provided through the element
    if ( mfem_this.attr('mfem_tooltip_dy') ) mfem_d_y = mfem_this.attr('mfem_tooltip_dy') * 1; // Set vertical distance, if provided through the element
    if ( mfem_this.attr('mfem_tooltip_dx') ) mfem_d_x = mfem_this.attr('mfem_tooltip_dx') * 1; // Set horizontal distance, if provided through the element
    var mfem_tooltip = mfem_this.attr('mfem_tooltip');
    mfem_jqueryTooltip.html(mfem_tooltip); // Define the mfem_tooltip
    var _t = e.pageY + mfem_d_y;
    var _l = e.pageX + mfem_d_x;
    mfem_jqueryTooltip.css({ 'top':_t, 'left':_l }); // Define location of the mfem_tooltip
    if ( mfem_tooltip != '' ) mfem_timeout = setTimeout( function(){mfem_jqueryTooltip.show(100).css('display','block');}, mfem_delay); // Show mfem_tooltip with delay as long as the string isn't empty.
  },
  function() { // Mouse out
    $('html,body').css('cursor',mfem_cursor); // Revert the cursor back to before
    clearTimeout(mfem_timeout); // Eliminate the timeout to avoid mfem_tooltip to be shown after mouse out
    mfem_jqueryTooltip.hide(100); // Hide mfem_tooltip without delay
    mfem_delay = mfem_delay_default; // back to default
    mfem_d_y = mfem_d_y_default; // back to default
    mfem_d_x = mfem_d_x_default; // back to default
  }).mousemove(function(e) { // Mouse moving
    var $ = jQuery;
    var _t = e.pageY + mfem_d_y;
    var _l = e.pageX + mfem_d_x;
    mfem_jqueryTooltip.css({ 'top':_t, 'left':_l });
  }).mousedown(function(e) { // to avoid cursor conflicts in case it is a button
    $('html,body').css('cursor',mfem_cursor); // Revert the cursor back to before
    clearTimeout(mfem_timeout); // Eliminate the timeout to avoid mfem_tooltip to be shown after mouse out
    mfem_jqueryTooltip.hide(100); // Hide mfem_tooltip without delay
    mfem_delay = mfem_delay_default; // back to default
    mfem_d_y = mfem_d_y_default; // back to default
    mfem_d_x = mfem_d_x_default; // back to default
  });
});

